{*********************************************************}
{*                                                       *}
{*       New ParamCount & ParamStr functions             *}
{*                                                       *}
{*       Copyright (c) 1995 Alexander Petrosyan          *}
{*                                                       *}
{*********************************************************}

unit
  NewParam;

interface

function ParamCount: Word;
function ParamStr (Index: Integer): string;
function GetParamsStarting (Index: Integer): string;
implementation

uses
  Objects,
  TPString;

var
  CommandLine: PString;
  Params: array [Byte] of record L, R: Byte; end;
  LocParamCount: Byte;

function ParamCount;
begin
  ParamCount := LocParamCount;
end;

function ParamStr;
begin
  if Index = 0
  then ParamStr := System.ParamStr (0)
  else with Params [Index-1] do ParamStr := Copy (CommandLine^, L, R-L);
end;

function GetParamsStarting;
begin
  with Params [Index-1] do GetParamsStarting := Copy (CommandLine^, L, $FF);
end;

const
  ParamDelims = [' ', #9];
  Quotes = ['"'];

var
  WaitForQuote: Boolean;
  B: Byte;
begin
  CommandLine := Ptr (PrefixSeg, $80);
  LocParamCount := 0;
  B := 0;
  while B <= Length (CommandLine^) do
  begin
    Inc (B);
    if CommandLine^ [B] in ParamDelims then Continue;
    with Params [LocParamCount] do
    begin
      WaitForQuote := CommandLine^ [B] in Quotes;
      if WaitForQuote then Inc (B);
      L:= B;
      while not (
        (B > Length (CommandLine^)) or
        WaitForQuote and (CommandLine^ [B] in Quotes) or
        not WaitForQuote and (CommandLine^ [B] in ParamDelims)) do
        Inc (B);
      R := B;
      if WaitForQuote then Inc (B);
    end;
    Inc (LocParamCount);
  end;
end.
